# Amazon CloudFront SDK

> _Warning:_ This is an experimental preview release which is still under heavy development and not intended for public consumption, _caveat emptor_!

* [Description](#description)
* [Contribute](#contribute)
* [Licence](#licence)

## Description

Amazon CloudFront is a web service that speeds up distribution of your static
and dynamic web content, for example, .html, .css, .php, image, and media
files, to end users. CloudFront delivers your content through a worldwide
network of edge locations. When an end user requests content that you're
serving with CloudFront, the user is routed to the edge location that
provides the lowest latency, so content is delivered with the best possible
performance. If the content is already in that edge location, CloudFront
delivers it immediately. If the content is not currently in that edge
location, CloudFront retrieves it from an Amazon S3 bucket or an HTTP server
(for example, a web server) that you have identified as the source for the
definitive version of your content.

Documentation is available via [Hackage](http://hackage.haskell.org/package/amazonka-cloudfront)
and the [AWS API Reference](http://docs.aws.amazon.com/AmazonCloudFront/latest/APIReference/Welcome.html).


## Contribute

For any problems, comments, or feedback please create an issue [here on GitHub](https://github.com/brendanhay/amazonka/issues).

> _Note:_ this library is an auto-generated Haskell package. Please see `amazonka-gen` for more information.


## Licence

`amazonka-cloudfront` is released under the [Mozilla Public License Version 2.0](http://www.mozilla.org/MPL/).

Parts of the code are derived from AWS service descriptions, licensed under Apache 2.0.
Source files subject to this contain an additional licensing clause in their header.
